/*
  ШИМ для клапана узла отбора дистиллята (ректификата) по принципу старт-стоп.
  Средний вывод переменного резистора 10 кОм подключен к выводу А0 ардуино.
  Крайние выводы переменного резистора - соответственно к "+" и  "-"
  На 7-м выводе ардуино снимаем сигнал для модуля реле, управляющего клапаном отбора.
  Можно использовать твердотельное реле для большей надежности (ресурс выше, чем у электромеханиеческого реле).
  Паузы задаются с помощью "millis". Можно применить и "delay", но тогда этот код не очень впишется в состав
  возможной программы для автоматизации отбора спирта по жидкости, где еще будет термодатчик и LCD. 
  Если кому интересно, могу выложить и вариант, где всё объединено в одном скетче.
  Период срабатывания клапана 8 секунд. Можно поменять в скетче. 
*/

const float pot=0;
uint32_t val, noval = 0;
int ledPin = 7;                 // LED, или реле подсоединен к выводу 7
unsigned long currentTime;
unsigned long loopTime;

void setup() 
{
  pinMode(ledPin, OUTPUT);      // устанавливаем вывод 7 как выход
  currentTime = millis();       // считываем время, прошедшее с момента запуска программы
  loopTime = currentTime;   
}

void loop() 
{
  float val = analogRead(pot);    //Присваиваем переменной, ответственной за включение, значение от угла поворота резистора.
                                  //Период, когда клапан включен (Весь угол поворота резистора равен значению от 0 до 1023).
  val = val * 8;                  //Увеличиваем скважность регулировки клапана до 8 секунд.
  noval = (1023*8 - val);         //Период, когда клапан выключен. Он равен значению остаточного сектора поворота резистора. 
 
  currentTime = millis();                               // считываем время, прошедшее с момента запуска программы
  if(currentTime >= (loopTime + val+noval)){           // 
    digitalWrite(ledPin, HIGH);                        // включаем LED
    loopTime = currentTime;                            // в loopTime записываем новое значение
  }

  currentTime = millis();                             // считываем время, прошедшее с момента запуска программы
  if(currentTime >= (loopTime + noval)){              // 
  digitalWrite(ledPin, LOW);                          // выключаем LED
  }

  if (val/8 <= 1)  digitalWrite(ledPin, HIGH);     // включаем клапан в крайнем левом положении резистора
  if (val/8 >= 1022) digitalWrite(ledPin, LOW);    // выключаем клапан в крайнем левом положении резистора

}



